﻿var currentDatasource;
var selectionsList;
var wereChecked = new Array();
var curPropCdsInd;
var curPropFInd;
var additionalCategories = new Array();
var needClick = false;
var realFilterParent;
var visualFilterParent;
var filtersTable;
var clonedFilters;
var groupingUsed;
var prevCatValue;
var fieldsDataObtained = false;

if (typeof IzLocal == 'undefined') { IzLocal = { Res: function (key, defaultValue) { return defaultValue; }, LocalizePage: function () { } }; }

//Util-----------------------------------------------------------------------------------------------------
function modifyUrl(parameterName, parameterValue) {
	var queryParameters = {}, queryString = location.search.substring(1),
            re = /([^&=]+)=([^&]*)/g, m;
	while (m = re.exec(queryString)) {
		queryParameters[decodeURIComponent(m[1])] = decodeURIComponent(m[2]);
	}
	queryParameters[parameterName] = parameterValue;
	location.search = jq$.param(queryParameters);
}

function updateURLParameter(url, param, paramVal) {
	var newAdditionalURL = "";
	var tempArray = url.split("?");
	var baseURL = tempArray[0];
	var additionalURL = tempArray[1];
	var temp = "";
	if (additionalURL) {
		tempArray = additionalURL.split("&");
		for (i = 0; i < tempArray.length; i++) {
			if (tempArray[i].split('=')[0] != param) {
				newAdditionalURL += temp + tempArray[i];
				temp = "&";
			}
		}
	}

	var rows_txt = temp + "" + param + "=" + paramVal;
	return baseURL + "?" + newAdditionalURL + rows_txt;
}

function IsIE() {
	if (navigator.appName == 'Microsoft Internet Explorer')
		return true;
	return false;
}

function GetDialogWidth() {
	var dialogWidth = 860; // default width for desktop
	if (jq$(window).width() < 900)
		dialogWidth = jq$(window).width() - 20;
	return dialogWidth;
}

function GetLoadingHtml() {
	var loading = jq$('#loadingDiv');
	if (loading == null || loading.length == 0)
		return '';
	return jq$('<div>').append(loading.clone().show()).html()
}

//------------------------------------------------------------------------------------------------------------------

//Ajax--------------------------------------------------------------------------------------------------------------
function AjaxRequest(url, parameters, callbackSuccess, callbackError, id, dataToKeep) {
	var thisRequestObject;
	if (window.XMLHttpRequest)
		thisRequestObject = new XMLHttpRequest();
	else if (window.ActiveXObject)
		thisRequestObject = new ActiveXObject('Microsoft.XMLHTTP');
	thisRequestObject.requestId = id;
	thisRequestObject.dtk = dataToKeep;
	thisRequestObject.onreadystatechange = ProcessRequest;

	/*thisRequestObject.open('GET', url + '?' + parameters, true);
    thisRequestObject.send();*/
	thisRequestObject.open('POST', url, true);
	thisRequestObject.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	thisRequestObject.send(parameters);

	function DeserializeJson() {
		var responseText = thisRequestObject.responseText;
		while (responseText.indexOf('"\\/Date(') >= 0) {
			responseText = responseText.replace('"\\/Date(', 'eval(new Date(');
			responseText = responseText.replace(')\\/"', '))');
		}
		if (responseText.charAt(0) != '[' && responseText.charAt(0) != '{')
			responseText = '{' + responseText + '}';
		var isArray = true;
		var isHtml = false;
		if (responseText.charAt(0) != '[') {
			responseText = '[' + responseText + ']';
			isArray = false;
		}
		var retObj;
		try {
			retObj = eval(responseText);
		}
		catch (e) {
			retObj = null;
		}
		if (retObj == null) {
			try {
				isHtml = true;
				retObj = eval(thisRequestObject.responseText);
			}
			catch (e) {
				retObj = null;
			}
		}
		if (retObj == null)
			return null;
		if (isHtml)
			return retObj;
		if (!isArray)
			return retObj[0];
		return retObj;
	}

	function ProcessRequest() {
		if (thisRequestObject.readyState == 4) {
			if (thisRequestObject.status == 200 && callbackSuccess) {
				var toRet;
				if (thisRequestObject.requestId != 'getrenderedreportset' && thisRequestObject.requestId != 'getcrsreportpartpreview' && thisRequestObject.requestId != 'renderedreportpart')
					toRet = DeserializeJson();
				else
					toRet = thisRequestObject.responseText;
				callbackSuccess(toRet, thisRequestObject.requestId, thisRequestObject.dtk);
			}
			else if (callbackError) {
				callbackError(thisRequestObject);
			}
		}
	}
}

function clearNames(elem) {
	jq$(elem).attr('name', '');
	jq$(elem).attr('id', '');
	for (var index = 0; index < elem.children.length; index++)
		clearNames(elem.children[index]);
}

function SendFieldsData(data) {
	var requestString = 'wscmd=updatecrsfields&wsarg0=' + encodeURIComponent(data);
	AjaxRequest('./rs.aspx', requestString, FieldsDataSent, null, 'updatecrsfields');
}

function FieldsDataSent(returnObj, id) {
	if (id != 'updatecrsfields' || returnObj == undefined || returnObj == null || returnObj.Value == null)
		return;
	GetFiltersData();
	//GetRenderedReportSet(true);
}
//------------------------------------------------------------------------------------------------------------------

//Common interface----------------------------------------------------------------------------------------------------
function DetectCurrentDs(dbName) {
	var newValue = -1;
	for (var index = 0; index < selectionsList.length; index++) {
		if (dbName == selectionsList[index].DbName) {
			newValue = index;
			break;
		}
	}
	currentDatasource = newValue;
}

function GetSelectedFieldInd() {
	var res = -1;
	var idCnt = 0;
	while (true) {
		var cb = document.getElementById('ufcb' + idCnt);
		if (cb == null)
			break;
		if (cb.checked) {
			if (res == -1)
				res = idCnt;
			else {
				res = -1;
				break;
			}
		}
		idCnt++;
	}
	return res;
}

function GetFieldIndexes(fieldDbName) {
	for (var dsCnt = 0; dsCnt < selectionsList.length; dsCnt++) {
		for (var fCnt = 0; fCnt < selectionsList[dsCnt].Fields.length; fCnt++) {
			if (selectionsList[dsCnt].Fields[fCnt].DbName == fieldDbName) {
				var indexes = new Array();
				indexes[indexes.length] = dsCnt;
				indexes[indexes.length] = fCnt;
				return indexes;
			}
		}
	}
	return null;
}

function InitiateEmail() {
	var fieldWithRn = document.getElementById('reportNameFor2ver');
	var rnVal;
	if (fieldWithRn != null)
		rnVal = fieldWithRn.value;
	else if (reportName == undefined || reportName == null)
		rnVal = '';
	else
		rnVal = reportName;
	while (rnVal.indexOf('+') >= 0) {
		rnVal = rnVal.replace('+', ' ');
	}
	TB_EMailReport(encodeURIComponent(rnVal), '?subject=' + encodeURIComponent(rnVal) + '&body=' + encodeURIComponent(location));
}

function ChangeTopRecords(recsNum, updateReportData) {
	for (var i = 0; i < 6; i++)
		jq$('#resNumLi' + i).removeClass('selected');
	var resNumImg = document.getElementById('resNumImg');
	var uvcVal = '100';
	var baseUrl = resNumImg.src.substr(0, resNumImg.src.lastIndexOf("ModernImages.") + 13);
	if (recsNum == 1) {
		uvcVal = '1';
		jq$('#resNumLi0').addClass('selected');
		resNumImg.src = nrvConfig.ResponseServerUrl + nrvConfig.serverDelimiter + 'image=ModernImages.' + 'row-1.png';
	}
	if (recsNum == 10) {
		uvcVal = '10';
		jq$('#resNumLi1').addClass('selected');
		resNumImg.src = nrvConfig.ResponseServerUrl + nrvConfig.serverDelimiter + 'image=ModernImages.' + 'rows-10.png';
	}
	if (recsNum == 100) {
		uvcVal = '100';
		jq$('#resNumLi2').addClass('selected');
		resNumImg.src = nrvConfig.ResponseServerUrl + nrvConfig.serverDelimiter + 'image=ModernImages.' + 'rows-100.png';
	}
	if (recsNum == 1000) {
		uvcVal = '1000';
		jq$('#resNumLi3').addClass('selected');
		resNumImg.src = nrvConfig.ResponseServerUrl + nrvConfig.serverDelimiter + 'image=ModernImages.' + 'rows-1000.png';
	}
	if (recsNum == 10000) {
		uvcVal = '10000';
		jq$('#resNumLi5').addClass('selected');
		resNumImg.src = nrvConfig.ResponseServerUrl + nrvConfig.serverDelimiter + 'image=ModernImages.' + 'rows-10000.png';
	}
	if (recsNum == -1) {
		uvcVal = '-1';
		jq$('#resNumLi4').addClass('selected');
		resNumImg.src = nrvConfig.ResponseServerUrl + nrvConfig.serverDelimiter + 'image=ModernImages.' + 'rows-all.png';
	}
	if (updateReportData) {
		SetTopRecords(uvcVal);
	}
}

function SetTopRecords(topRecords) {
	var requestString = 'wscmd=settoprecords&wsarg0=' + topRecords;
	AjaxRequest('./rs.aspx', requestString, TopRecordsSet, null, 'settoprecords');
}

function TopRecordsSet(returnObj, id) {
	if (id != 'settoprecords' || returnObj == undefined || returnObj == null)
		return;
	if (returnObj.Value != 'OK') {
		alert(returnObj.Value);
		return;
	}
	GetRenderedReportSet(false);
}

function RefreshFieldsList() {
	var remainingHtml = "<table>";
	var usedHtml = "<table width=\"100%\">";
	var uCnt = 0;
	var rCnt = 0;
	var cdsBegin = currentDatasource;
	var cdsEnd = currentDatasource + 1;
	if (currentDatasource == -1) {
		cdsBegin = 0;
		cdsEnd = selectionsList.length;
	}
	var selectedFields = new Array();
	for (var cds = cdsBegin; cds < cdsEnd; cds++) {
		for (var fCnt = 0; fCnt < selectionsList[cds].Fields.length; fCnt++) {
			var idPrefix;
			var trActions;
			if (selectionsList[cds].Fields[fCnt].Selected > -1) {
				idPrefix = 'ufcb' + uCnt;
				uCnt++;
				trActions = ' onmouseover="javascript:this.children[2].style.opacity=0.5;" onmouseout="javascript:this.children[2].style.opacity=0;"';
			}
			else {
				idPrefix = 'rfcb' + rCnt;
				rCnt++;
				trActions = '';
			}
			var wasChecked = '';
			for (var index = 0; index < wereChecked.length; index++) {
				if (wereChecked[index] == selectionsList[cds].Fields[fCnt].DbName) {
					wasChecked = ' checked="checked"';
					break;
				}
			}
			var clickProcess = '';
			if (selectionsList[cds].Fields[fCnt].Selected > -1)
				clickProcess = 'onchange="javascript:var fpButton = document.getElementById(\'fpButton\'); if (GetSelectedFieldInd() >= 0) {jq$(fpButton).removeClass(\'disabled\');} else {jq$(fpButton).addClass(\'disabled\');}"';
			var lColor = '';
			var fieldOpt = '';
			if (!selectionsList[cds].Fields[fCnt].Hidden) {
				fieldOpt += '<tr' + trActions + '><td width="15"><input type="checkbox" id="' + idPrefix + '" cdsInd="' + cds + '" fInd="' + fCnt + '" value="' + selectionsList[cds].Fields[fCnt].DbName + '"' + wasChecked + clickProcess + ' /></td>';
			}
			else {
				fieldOpt += '<tr style="display:none;"' + trActions + '><td width="15"><input type="checkbox" id="' + idPrefix + '" cdsInd="' + cds + '" fInd="' + fCnt + '" value="' + selectionsList[cds].Fields[fCnt].DbName + '" disabled="disabled" /></td>';
				lColor = 'color:#808080;';
			}
			fieldOpt += '<td><label style="cursor:pointer;' + lColor + '" for="' + idPrefix + '">' + selectionsList[cds].Fields[fCnt].FriendlyName + '</label></td>';
			if (!selectionsList[cds].Fields[fCnt].Hidden)
				fieldOpt += '<td onmouseover="javascript:this.style.opacity=1;var e=event?event:window.event;if(e){e.cancelBubble = true;if(e.stopPropagation){e.stopPropagation();}}" onmouseout="javascript:this.style.opacity=0;" onclick="javascript:ShowFieldPropertiesForField(this.parentElement.children[0].children[0]);" width="15" style="opacity:0; cursor:pointer; background-image:url(rs.aspx?image=gear.gif); background-repeat:no-repeat; background-position:0px 4px;"></td>';
			fieldOpt += "</tr>";
			if (selectionsList[cds].Fields[fCnt].Selected > -1) {
				var selectedHtml = new Object();
				selectedHtml.Text = fieldOpt;
				selectedHtml.OrderNum = selectionsList[cds].Fields[fCnt].Selected;
				selectedFields[selectedFields.length] = selectedHtml;
			}
			else
				remainingHtml += fieldOpt;
		}
	}
	for (var ind1 = 0; ind1 < selectedFields.length - 1; ind1++) {
		for (var ind2 = ind1 + 1; ind2 < selectedFields.length; ind2++) {
			if (selectedFields[ind1].OrderNum > selectedFields[ind2].OrderNum) {
				var tmpText = selectedFields[ind1].Text;
				var tmpOrder = selectedFields[ind1].OrderNum;
				selectedFields[ind1].Text = selectedFields[ind2].Text;
				selectedFields[ind1].OrderNum = selectedFields[ind2].OrderNum;
				selectedFields[ind2].Text = tmpText;
				selectedFields[ind2].OrderNum = tmpOrder;
			}
		}
	}
	for (var index = 0; index < selectedFields.length; index++)
		usedHtml += selectedFields[index].Text;
	usedHtml += '</table>';
	remainingHtml += '</table>';
	var remaining = document.getElementById('remainingFieldsSel');
	var used = document.getElementById('usedFieldsSel');
	remaining.innerHTML = remainingHtml;
	used.innerHTML = usedHtml;
	var fpButton = document.getElementById('fpButton');
	if (wereChecked.length != 1)
		jq$(fpButton).addClass('disabled');
	else
		jq$(fpButton).removeClass('disabled');
	if (typeof filtersDataObtained != 'undefined' && filtersDataObtained && fieldsDataObtained)
		CheckShowAddFilterControls();
}

function updateFields() {
	var usageData = new Object();
	usageData.Fields = new Array();
	for (var dsCnt = 0; dsCnt < selectionsList.length; dsCnt++) {
		for (var fCnt = 0; fCnt < selectionsList[dsCnt].Fields.length; fCnt++) {
			var definedAsFilter = false;
			if (selectionsList[dsCnt].Fields[fCnt].FilterOperator != null && selectionsList[dsCnt].Fields[fCnt].FilterOperator != '' && selectionsList[dsCnt].Fields[fCnt].FilterOperator != '...')
				definedAsFilter = true;
			if (selectionsList[dsCnt].Fields[fCnt].Selected > -1 || definedAsFilter) {
				var usedField = new Object();
				usedField.FriendlyName = selectionsList[dsCnt].Fields[fCnt].FriendlyName;
				usedField.DbName = selectionsList[dsCnt].Fields[fCnt].DbName;
				usedField.Selected = selectionsList[dsCnt].Fields[fCnt].Selected;
				usedField.Total = selectionsList[dsCnt].Fields[fCnt].Total;
				usedField.VG = selectionsList[dsCnt].Fields[fCnt].VG;
				usedField.IsMultilineHeader = selectionsList[dsCnt].Fields[fCnt].IsMultilineHeader;
				usedField.Description = selectionsList[dsCnt].Fields[fCnt].Description;
				usedField.Format = selectionsList[dsCnt].Fields[fCnt].Format;
				usedField.Width = selectionsList[dsCnt].Fields[fCnt].Width;
				usedField.FilterOperator = selectionsList[dsCnt].Fields[fCnt].FilterOperator;
				usedField.LabelJ = selectionsList[dsCnt].Fields[fCnt].LabelJ;
				usedField.ValueJ = selectionsList[dsCnt].Fields[fCnt].ValueJ;
				usageData.Fields[usageData.Fields.length] = usedField;
			}
		}
	}
	var s = JSON.stringify(usageData);
	wereChecked.length = 0;
	RefreshFieldsList();
	SendFieldsData(s);
}

function UpdateFieldsAndRefresh() {
	updateFields();
	GetRenderedReportSet(true);
}

//------------------------------------------------------------------------------------------------------------------

//Pivots control--------------------------------------------------------------------------------------------------
function RefreshPivots() {
	var requestString = 'wscmd=getpivotguidata';
	AjaxRequest('./rs.aspx', requestString, PivotsDataGot, null, 'getpivotguidata');
}

function PivotsDataGot(returnObj, id) {
	if (id != 'getpivotguidata' || returnObj == undefined || returnObj == null)
		return;
	if (returnObj.CurrentField == '' || returnObj.FieldNames == null) {
		jq$(".visibility-pivots").hide();
		return;
	}
	if (!nrvConfig.ReportIsLocked)
		jq$(".visibility-pivots").show();
	var pivotHtml = '<div>' + IzLocal.Res('js_Column', 'Column').toUpperCase() + '</div>';
	pivotHtml += '<select id="pivot-field" onchange="SetPivotField();">';
	for (var i = 0; i < returnObj.FieldNames.length; i++) {
		var selected = '';
		if (returnObj.CurrentField == returnObj.FieldIds[i])
			selected = ' selected="selected"';
		if (returnObj.FieldIds[i] == '') {
			if (returnObj.FieldNames[i] == '------') {
				pivotHtml += '<option disabled="">------</option>';
			}
			else {
				if (returnObj.FieldNames[i] == '') {
					pivotHtml += '</optgroup>';
				}
				else {
					pivotHtml += '<optgroup label="' + returnObj.FieldNames[i] + '">';
				}
			}
			continue;
		}
		pivotHtml += '<option value="' + returnObj.FieldIds[i] + '"' + selected + '>' + returnObj.FieldNames[i] + '</option>';
	}
	pivotHtml += '</select><br />';
	pivotHtml += '<div>' + IzLocal.Res('js_Function', 'Function').toUpperCase() + '</div>';
	pivotHtml += '<select id="pivot-function" onchange="SetPivotFunction();">';
	for (var i = 0; i < returnObj.FunctionNames.length; i++) {
		var selected = '';
		if (returnObj.CurrentFunction == returnObj.FunctionIds[i])
			selected = ' selected="selected"';
		pivotHtml += '<option value="' + returnObj.FunctionIds[i] + '"' + selected + '>' + returnObj.FunctionNames[i] + '</option>';
	}
	pivotHtml += '</select><br />';
	var pivotSelector = document.getElementById('pivot-selector');
	pivotSelector.innerHTML = pivotHtml;
}

function SetPivotField() {
	var requestString = 'wscmd=setpivotfield&wsarg0=' + document.getElementById('pivot-field').value;
	AjaxRequest('./rs.aspx', requestString, PivotFieldSet, null, 'setpivotfield');
}

function PivotFieldSet(returnObj, id) {
	if (id != 'setpivotfield' || returnObj == undefined || returnObj == null || returnObj.Value == null)
		return;
	if (returnObj.Value != 'OK')
		alert(returnObj.Value);
	RefreshPivots();
}

function SetPivotFunction() {
	var requestString = 'wscmd=setpivotfunction&wsarg0=' + document.getElementById('pivot-function').value;
	AjaxRequest('./rs.aspx', requestString, PivotFunctionSet, null, 'setpivotfunction');
}

function PivotFunctionSet(returnObj, id) {
	if (id != 'setpivotfunction' || returnObj == undefined || returnObj == null || returnObj.Value == null)
		return;
	if (returnObj.Value != 'OK')
		alert(returnObj.Value);
	RefreshPivots();
}
//------------------------------------------------------------------------------------------------------------------

//Field advanced properties-------------------------------------------------------------------------------------------------------
function ShowFieldPropertiesByFullFieldName(fieldName) {
	var foundC = -1;
	var foundF = -1;
	for (var cInd = 0; cInd < selectionsList.length && foundC < 0 && foundF < 0; cInd++) {
		for (var fInd = 0; fInd < selectionsList[cInd].Fields.length && foundC < 0 && foundF < 0; fInd++) {
			if (selectionsList[cInd].Fields[fInd].DbName == fieldName || selectionsList[cInd].Fields[fInd].Description == fieldName) {
				foundC = cInd;
				foundF = fInd;
				break;
			}
		}
	}
	if (foundC >= 0 && foundF >= 0) {
		curPropCdsInd = foundC;
		curPropFInd = foundF;
		FP_ShowFieldProperties(selectionsList[curPropCdsInd].Fields[curPropFInd], fieldPopup);
	}
}

function ShowFieldPropertiesForField(fieldCb) {
	curPropCdsInd = fieldCb.getAttribute('cdsInd');
	curPropFInd = fieldCb.getAttribute('fInd');
	FP_ShowFieldProperties(selectionsList[curPropCdsInd].Fields[curPropFInd], fieldPopup);
}

function ShowFieldProperties() {
	var fieldInd = GetSelectedFieldInd();
	var fieldCb = document.getElementById('ufcb' + fieldInd);
	if (fieldCb == null)
		return;
	ShowFieldPropertiesForField(fieldCb);
}

function updateFieldProperties(newField) {
	selectionsList[curPropCdsInd].Fields[curPropFInd].Description = newField.Description;
	selectionsList[curPropCdsInd].Fields[curPropFInd].Total = newField.Total;
	selectionsList[curPropCdsInd].Fields[curPropFInd].VG = newField.VG
	selectionsList[curPropCdsInd].Fields[curPropFInd].IsMultilineHeader = newField.IsMultilineHeader;
	selectionsList[curPropCdsInd].Fields[curPropFInd].Format = newField.Format;
	selectionsList[curPropCdsInd].Fields[curPropFInd].Width = newField.Width;
	selectionsList[curPropCdsInd].Fields[curPropFInd].FilterOperator = newField.FilterOperator;
	selectionsList[curPropCdsInd].Fields[curPropFInd].LabelJ = newField.LabelJ;
	selectionsList[curPropCdsInd].Fields[curPropFInd].ValueJ = newField.ValueJ;
	updateFields();
}
//------------------------------------------------------------------------------------------------------------------

//Fields list-----------------------------------------------------------------------------------------------------------
function AddRemainingFields() {
	var newInd = -1;
	cdsBegin = 0;
	cdsEnd = selectionsList.length;
	for (var cds = cdsBegin; cds < cdsEnd; cds++) {
		for (var fCnt = 0; fCnt < selectionsList[cds].Fields.length; fCnt++) {
			if (newInd < selectionsList[cds].Fields[fCnt].Selected)
				newInd = selectionsList[cds].Fields[fCnt].Selected;
		}
	}
	newInd++;
	var idCnt = 0;
	while (true) {
		var cb = document.getElementById('rfcb' + idCnt);
		if (cb == null)
			break;
		if (cb.checked) {
			var ci = cb.getAttribute('cdsInd');
			var fi = cb.getAttribute('fInd');
			selectionsList[ci].Fields[fi].Selected = newInd;
			selectionsList[ci].Fields[fi].LabelJ = 1;
			selectionsList[ci].Fields[fi].ValueJ = 0;
			selectionsList[ci].Fields[fi].Description = selectionsList[ci].Fields[fi].FriendlyName;
			newInd++;
		}
		idCnt++;
	}
	wereChecked.length = 0;
	RefreshFieldsList();
}

function RemoveUsedFields() {
	var idCnt = 0;
	while (true) {
		var cb = document.getElementById('ufcb' + idCnt);
		if (cb == null)
			break;
		if (cb.checked) {
			selectionsList[cb.getAttribute('cdsInd')].Fields[cb.getAttribute('fInd')].Selected = -1;
		}
		idCnt++;
	}
	var selectedFields = new Array();
	cdsBegin = 0;
	cdsEnd = selectionsList.length;
	for (var cds = cdsBegin; cds < cdsEnd; cds++) {
		for (var fCnt = 0; fCnt < selectionsList[cds].Fields.length; fCnt++) {
			if (selectionsList[cds].Fields[fCnt].Selected > -1) {
				var selectedHtml = new Object();
				selectedHtml.DsNum = cds;
				selectedHtml.FNum = fCnt;
				selectedHtml.OrderNum = selectionsList[cds].Fields[fCnt].Selected;
				selectedFields[selectedFields.length] = selectedHtml;
			}
		}
	}
	for (var ind1 = 0; ind1 < selectedFields.length - 1; ind1++) {
		for (var ind2 = ind1 + 1; ind2 < selectedFields.length; ind2++) {
			if (selectedFields[ind1].OrderNum > selectedFields[ind2].OrderNum) {
				var tmpDsNum = selectedFields[ind1].DsNum;
				var tmpFNum = selectedFields[ind1].FNum;
				var tmpOrder = selectedFields[ind1].OrderNum;
				selectedFields[ind1].DsNum = selectedFields[ind2].DsNum;
				selectedFields[ind1].FNum = selectedFields[ind2].FNum;
				selectedFields[ind1].OrderNum = selectedFields[ind2].OrderNum;
				selectedFields[ind2].DsNum = tmpDsNum;
				selectedFields[ind2].FNum = tmpFNum;
				selectedFields[ind2].OrderNum = tmpOrder;
			}
		}
	}
	for (var index = 0; index < selectedFields.length; index++)
		selectionsList[selectedFields[index].DsNum].Fields[selectedFields[index].FNum].Selected = index;
	wereChecked.length = 0;
	RefreshFieldsList();
}

function MoveUp() {
	var selectedFields = new Array();
	for (var dsCnt = 0; dsCnt < selectionsList.length; dsCnt++) {
		for (var fCnt = 0; fCnt < selectionsList[dsCnt].Fields.length; fCnt++) {
			if (selectionsList[dsCnt].Fields[fCnt].Selected > -1) {
				var usedField = new Object();
				usedField.FriendlyName = selectionsList[dsCnt].Fields[fCnt].FriendlyName;
				usedField.DbName = selectionsList[dsCnt].Fields[fCnt].DbName;
				usedField.Selected = selectionsList[dsCnt].Fields[fCnt].Selected;
				usedField.ToMove = false;
				usedField.DbNum = dsCnt;
				usedField.FNum = fCnt;
				selectedFields[selectedFields.length] = usedField;
			}
		}
	}
	var idCnt = 0;
	wereChecked = new Array();
	while (true) {
		var cb = document.getElementById('ufcb' + idCnt);
		if (cb == null)
			break;
		if (cb.checked) {
			for (var sCnt = 0; sCnt < selectedFields.length; sCnt++) {
				if (selectedFields[sCnt].DbName == cb.value) {
					selectedFields[sCnt].ToMove = true;
					wereChecked[wereChecked.length] = selectedFields[sCnt].DbName;
				}
			}
		}
		idCnt++;
	}
	for (var ind1 = 0; ind1 < selectedFields.length - 1; ind1++) {
		for (var ind2 = ind1 + 1; ind2 < selectedFields.length; ind2++) {
			if (selectedFields[ind1].Selected > selectedFields[ind2].Selected) {
				var tmp = selectedFields[ind1];
				selectedFields[ind1] = selectedFields[ind2];
				selectedFields[ind2] = tmp;
			}
		}
	}
	for (var cnt = 1; cnt < selectedFields.length; cnt++) {
		if (selectedFields[cnt].ToMove && !selectedFields[cnt - 1].ToMove) {
			var tmp = selectedFields[cnt - 1];
			selectedFields[cnt - 1] = selectedFields[cnt];
			selectedFields[cnt] = tmp;
		}
	}
	for (var cnt = 0; cnt < selectedFields.length; cnt++)
		selectionsList[selectedFields[cnt].DbNum].Fields[selectedFields[cnt].FNum].Selected = cnt;
	RefreshFieldsList();
}

function MoveDown() {
	var selectedFields = new Array();
	for (var dsCnt = 0; dsCnt < selectionsList.length; dsCnt++) {
		for (var fCnt = 0; fCnt < selectionsList[dsCnt].Fields.length; fCnt++) {
			if (selectionsList[dsCnt].Fields[fCnt].Selected > -1) {
				var usedField = new Object();
				usedField.FriendlyName = selectionsList[dsCnt].Fields[fCnt].FriendlyName;
				usedField.DbName = selectionsList[dsCnt].Fields[fCnt].DbName;
				usedField.Selected = selectionsList[dsCnt].Fields[fCnt].Selected;
				usedField.ToMove = false;
				usedField.DbNum = dsCnt;
				usedField.FNum = fCnt;
				selectedFields[selectedFields.length] = usedField;
			}
		}
	}
	var idCnt = 0;
	wereChecked = new Array();
	while (true) {
		var cb = document.getElementById('ufcb' + idCnt);
		if (cb == null)
			break;
		if (cb.checked) {
			for (var sCnt = 0; sCnt < selectedFields.length; sCnt++) {
				if (selectedFields[sCnt].DbName == cb.value) {
					selectedFields[sCnt].ToMove = true;
					wereChecked[wereChecked.length] = selectedFields[sCnt].DbName;
				}
			}
		}
		idCnt++;
	}
	for (var ind1 = 0; ind1 < selectedFields.length - 1; ind1++) {
		for (var ind2 = ind1 + 1; ind2 < selectedFields.length; ind2++) {
			if (selectedFields[ind1].Selected > selectedFields[ind2].Selected) {
				var tmp = selectedFields[ind1];
				selectedFields[ind1] = selectedFields[ind2];
				selectedFields[ind2] = tmp;
			}
		}
	}
	for (var cnt = selectedFields.length - 2; cnt >= 0; cnt--) {
		if (selectedFields[cnt].ToMove && !selectedFields[cnt + 1].ToMove) {
			var tmp = selectedFields[cnt + 1];
			selectedFields[cnt + 1] = selectedFields[cnt];
			selectedFields[cnt] = tmp;
		}
	}
	for (var cnt = 0; cnt < selectedFields.length; cnt++)
		selectionsList[selectedFields[cnt].DbNum].Fields[selectedFields[cnt].FNum].Selected = cnt;
	RefreshFieldsList();
}
//------------------------------------------------------------------------------------------------------------------------


//Save and Save As code----------------------------------------------------------------------------------------------------------
function GetCategoriesList(setRn) {
	var requestString = 'wscmd=crscategories';
	AjaxRequest('./rs.aspx', requestString, GotCategoriesList, null, 'crscategories', setRn);
}

function GotCategoriesList(returnObj, id, setRn) {
	if (id != 'crscategories' || returnObj == undefined || returnObj == null)
		return;
	var fieldWithRn = document.getElementById('reportNameFor2ver');
	var rnVal;
	if (fieldWithRn != null)
		rnVal = fieldWithRn.value;
	else if (reportName == undefined || reportName == null)
		rnVal = '';
	else
		rnVal = reportName;
	while (rnVal.indexOf('+') >= 0) {
		rnVal = rnVal.replace('+', ' ');
	}
	var nodes = rnVal.split(nrvConfig.CategoryCharacter);
	var curCatName = '';
	var curRepName = nodes[0];
	if (nodes.length > 1) {
		curCatName = nodes[0];
		curRepName = nodes[1];
	}
	var newReportName = document.getElementById('newReportName');
	var newCategoryName = document.getElementById('newCategoryName');
	if (setRn) {
		newReportName.value = curRepName;
	}
	var catsArray = new Array();
	catsArray[catsArray.length] = '';
	for (var acCnt = 0; acCnt < additionalCategories.length; acCnt++)
		catsArray[catsArray.length] = additionalCategories[acCnt];
	if (returnObj.AdditionalData != null && returnObj.AdditionalData.length > 0)
		for (var index = 0; index < returnObj.AdditionalData.length; index++)
			catsArray[catsArray.length] = returnObj.AdditionalData[index];
	newCategoryName.options.length = 0;
	//var opt = new Option();
	//opt.value = IzLocal.Res('js_CreateNew', '(Create new)');
	//opt.text = IzLocal.Res('js_CreateNew', '(Create new)');
	//newCategoryName.add(opt);
	for (var index = 0; index < catsArray.length; index++) {
		var opt = new Option();
		opt.value = catsArray[index];
		var ot = catsArray[index];
		while (ot.indexOf('+') >= 0) {
			ot = ot.replace('+', ' ');
		}
		opt.text = ot;
		if (opt.text == curCatName && additionalCategories.length == 0)
			opt.selected = 'selected';
		if (additionalCategories.length > 0 && opt.text == additionalCategories[additionalCategories.length - 1])
			opt.selected = 'selected';
		newCategoryName.add(opt);
	}
	var saveAsDialog = document.getElementById('saveAsDialog');
	var windowHeight = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : document.body.clientHeight;
	saveAsDialog.style.height = windowHeight + 'px';
	saveAsDialog.style.paddingTop = ((windowHeight / 2) - 100) + 'px';
	saveAsDialog.style.display = '';
	prevCatValue = newCategoryName.value;
}

function ShowSaveAsDialog() {
	additionalCategories.length = 0;
	GetCategoriesList(true);
}

function SaveReportAs() {
	var newRepName = document.getElementById('newReportName').value;
	var newCatName = document.getElementById('newCategoryName').value;
	var fieldWithRn = document.getElementById('reportNameFor2ver');
	var newFullName = newRepName;
	if (newCatName != null && newCatName != '' && newCatName != IzLocal.Res('js_Uncategorized', 'Uncategorized')) {
		newFullName = newCatName + nrvConfig.CategoryCharacter + newFullName;
	}
	while (newFullName.indexOf(' ') >= 0) {
		newFullName = newFullName.replace(' ', '+');
	}
	if (fieldWithRn != null) {
		fieldWithRn.value = newFullName;
	}
	else {
		reportName = newFullName;
	}
	var saveAsDialog = document.getElementById('saveAsDialog');
	saveAsDialog.style.display = 'none';
	SaveReportSet();
}

function SaveReportSet() {
	var fieldWithRn = document.getElementById('reportNameFor2ver');
	var rnVal;
	if (fieldWithRn != null)
		rnVal = fieldWithRn.value;
	else if (reportName == undefined || reportName == null)
		rnVal = '';
	else
		rnVal = reportName;
	while (rnVal.indexOf('+') >= 0) {
		rnVal = rnVal.replace('+', ' ');
	}
	if (rnVal == null || rnVal == '') {
		ShowSaveAsDialog();
		return;
	}
	var loadingrv2 = document.getElementById('loadingrv2');
	var windowHeight = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : document.body.clientHeight;
	loadingrv2.style.height = windowHeight + 'px';
	loadingrv2.style.paddingTop = ((windowHeight / 2) - 100) + 'px';
	loadingrv2.style.display = '';
	var requestString = 'wscmd=savecurrentreportset';
	requestString += '&wsarg0=' + rnVal;
	AjaxRequest('./rs.aspx', requestString, ReportSetSaved, null, 'savecurrentreportset');
}

function ReportSetSaved(returnObj, id) {
	if (id != 'savecurrentreportset' || returnObj == undefined || returnObj == null || returnObj.Value == null)
		return;
	document.getElementById('loadingrv2').style.display = 'none';
	if (returnObj.Value != 'OK') {
		alert(returnObj.Value);
	}
	else {
		var fieldWithRn = document.getElementById('reportNameFor2ver');
		var rnVal;
		if (fieldWithRn != null) {
			rnVal = fieldWithRn.value;
		}
		else {
			rnVal = reportName;
		}
		modifyUrl('rn', rnVal);
	}
}

function ShowNewCatDialog() {
	document.getElementById('addedCatName').value = '';
	var saveAsDialog = document.getElementById('saveAsDialog');
	saveAsDialog.style.display = 'none';
	var newCatDialog = document.getElementById('newCatDialog');
	var windowHeight = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : document.body.clientHeight;
	newCatDialog.style.height = windowHeight + 'px';
	newCatDialog.style.paddingTop = ((windowHeight / 2) - 100) + 'px';
	newCatDialog.style.display = '';
}

function AddNewCategory() {
	additionalCategories[additionalCategories.length] = document.getElementById('addedCatName').value;
	var newCatDialog = document.getElementById('newCatDialog').style.display = 'none';
	GetCategoriesList(false);
}
//------------------------------------------------------------------------------------------------------------------------


//Exports ----------------------------------------------------------------------------------------------------------

function GetExport(format) {
	var reportNameParam = '';
	var fieldWithRn = document.getElementById('reportNameFor2ver');
	var rnVal;
	if (fieldWithRn != null)
		rnVal = fieldWithRn.value;
	else if (reportName == undefined || reportName == null)
		rnVal = '';
	else
		rnVal = reportName;
	rnVal = rnVal.replace(/\+/g, ' ');
	if (rnVal)
		reportNameParam = '&rn=' + rnVal;

	var urlParams = responseServerWithDelimeter + 'output=' + format;
	if (reportNameParam)
		urlParams = urlParams + reportNameParam;

	responseServer.OpenUrlWithModalDialogNewCustomRsUrl(urlParams, 'aspnetForm', 'reportFrame', nrvConfig.ResponseServerUrl);
}

//------------------------------------------------------------------------------------------------------------------------

// Field properties

function FP_ShowFieldProperties(field, dialog) {
	var titleDiv = document.getElementById('titleDiv');
	var titleText = IzLocal.Res('js_FieldPropertyForField', 'Field Properties for {0}').replace(/\{0\}/g, field.FriendlyName);
	titleDiv.innerHTML = titleText
	var propDescription = document.getElementById('propDescription');
	if (field.Selected >= 0)
		propDescription.disabled = false;
	else
		propDescription.disabled = true;
	propDescription.value = field.Description;
	var propTotal = document.getElementById('propTotal');
	propTotal.checked = false;
	if (field.Total == 1)
		propTotal.checked = true;
	var propVG = document.getElementById('propVG');
	propVG.checked = false;
	if (field.VG == 1)
		propVG.checked = true;
	var propMultilineHeader = document.getElementById('propMultilineHeader');
	propMultilineHeader.checked = false;
	if (field.IsMultilineHeader == 1)
		propMultilineHeader.checked = true;
	var propFormats = document.getElementById('propFormats');
	propFormats.options.length = 0;
	for (var formatCnt = 0; formatCnt < field.FormatValues.length; formatCnt++) {
		var opt = new Option();
		opt.value = field.FormatValues[formatCnt];
		opt.text = field.FormatNames[formatCnt];
		if (field.Format == field.FormatValues[formatCnt])
			opt.selected = 'selected';
		propFormats.add(opt);
	}
	var propFilterOperators = document.getElementById('propFilterOperators');
	propFilterOperators.options.length = 0;
	while (propFilterOperators.hasChildNodes())
		propFilterOperators.removeChild(propFilterOperators.firstChild);
	var currentOptGroup = null;
	for (var filterOperatorCnt = 0; filterOperatorCnt < field.FilterOperatorValues.length; filterOperatorCnt++) {
		if (field.FilterOperatorValues[filterOperatorCnt] == '###OPTGROUP###') {
			if (field.FilterOperatorNames[filterOperatorCnt] != '') {
				currentOptGroup = document.createElement('optgroup');
				currentOptGroup.label = field.FilterOperatorNames[filterOperatorCnt];
				propFilterOperators.appendChild(currentOptGroup);
			}
			continue;
		}
		var opt = new Option();
		opt.value = field.FilterOperatorValues[filterOperatorCnt];
		opt.text = field.FilterOperatorNames[filterOperatorCnt];
		if (field.FilterOperator == field.FilterOperatorValues[filterOperatorCnt])
			opt.selected = 'selected';
		if (currentOptGroup == null)
			propFilterOperators.add(opt);
		else
			currentOptGroup.appendChild(opt);
	}
	var labelJ = document.getElementById('labelJ');
	var msvs = labelJ.getAttribute('msvs').split(',');
	labelJ.innerHTML = msvs[field.LabelJ - 1];
	labelJ.setAttribute('msv', msvs[field.LabelJ - 1]);
	var valueJ = document.getElementById('valueJ');
	msvs = valueJ.getAttribute('msvs').split(',');
	valueJ.innerHTML = msvs[field.ValueJ];
	valueJ.setAttribute('msv', msvs[field.ValueJ]);
	if (IsIE()) {
		jq$('.multi-valued-check-advanced').css("margin-left", '3px');
	}
	dialog.dialog("option", "title", field.FriendlyName);
	dialog.dialog("open");
}

function FP_CollectProperties() {
	var field = new Object();
	field.Description = document.getElementById('propDescription').value;
	var propTotal = document.getElementById('propTotal');
	if (propTotal.checked)
		field.Total = 1;
	else
		field.Total = 0;
	var propVG = document.getElementById('propVG');
	if (propVG.checked)
		field.VG = 1;
	else
		field.VG = 0;
	var propMultilineHeader = document.getElementById('propMultilineHeader');
	if (propMultilineHeader.checked)
		field.IsMultilineHeader = 1;
	else
		field.IsMultilineHeader = 0;
	var propFormats = document.getElementById('propFormats');
	field.Format = propFormats.value;
	var propFilterOperators = document.getElementById('propFilterOperators');
	field.FilterOperator = propFilterOperators.value;
	var labelJ = document.getElementById('labelJ');
	var msvs = labelJ.getAttribute('msvs').split(',');
	var msv = labelJ.getAttribute('msv');
	var curInd = 0;
	for (var ind = 0; ind < msvs.length; ind++) {
		if (msvs[ind] == msv) {
			curInd = ind;
			break;
		}
	}
	field.LabelJ = curInd + 1;
	var valueJ = document.getElementById('valueJ');
	var msvs = valueJ.getAttribute('msvs').split(',');
	var msv = valueJ.getAttribute('msv');
	var curInd = 0;
	for (var ind = 0; ind < msvs.length; ind++) {
		if (msvs[ind] == msv) {
			curInd = ind;
			break;
		}
	}
	field.ValueJ = curInd;
	return field;
}

function FP_AppendDialogMarkup(parent, forInstantReports) {
	parent.innerHTML = FP_DialogMarkup(forInstantReports);
}

function UpdateMSV(lid, updatePreview) {
	var label = document.getElementById(lid);
	var msvs = label.getAttribute('msvs').split(',');
	var msv = label.getAttribute('msv');
	var curInd = -1;
	for (var ind = 0; ind < msvs.length; ind++) {
		if (msvs[ind] == msv) {
			curInd = ind;
			break;
		}
	}
	curInd++;
	if (curInd >= msvs.length)
		curInd = 0;
	label.setAttribute('msv', msvs[curInd]);
	label.innerHTML = msvs[curInd];
	if (updatePreview)
		PreviewFieldDelayed(1000);
}

function FP_DialogMarkup(forInstantReports) {
	var preview = '';
	var previewChangeEvent = '';
	var previewKeyUpEvent = '';
	var previewMouseUpEvent = '';
	if (forInstantReports) {
		preview = '<td style="vertical-align:top"><div id="fieldSamplePreview" style="width:200px;"></div></td>';
		previewChangeEvent = ' onchange="PreviewFieldDelayed(1000);"';
		previewKeyUpEvent = ' onkeyup="PreviewFieldDelayed(1000);"';
		previewMouseUpEvent = ' onmouseup="PreviewFieldDelayed(1000);"';
	}
	var markup = '\
			<div id="data-source-field" title="Field name" lang-title="js_FieldName">\
			<div id="propertiesDiv" style="height: 340px;">\
				<table style="width:100%;">\
					<tr>\
						<td>\
							<div id="titleDiv" style="width:100%;text-align:left;text-transform:capitalize;color:#000000;background-color:#CCEEFF;padding:6px;">11</div>\
							<table cellpadding="0" cellspacing="0">\
								<tr>\
									<td style="vertical-align:top">\
										<table cellpadding="0" cellspacing="0">\
											<tr><td style="padding-top:10px;" lang-text="js_Description">Description</td></tr>\
											<tr><td><input id="propDescription" type="text" value="" style="width:400px;margin:0px;"' + previewKeyUpEvent + ' /></td></tr>\
											<tr><td style="padding-top:10px;" lang-text="js_Format">Format</td></tr>\
											<tr><td><select id="propFormats" style="margin:0px;width:406px;"' + previewChangeEvent + ' ></select></td></tr>\
											<tr><td style="padding-top:10px;" lang-text="js_FilterOperator">Filter Operator</td></tr>\
											<tr><td><select id="propFilterOperators" style="margin:0px;width:406px;"' + previewChangeEvent + ' ></select></td></tr>\
										</table>\
									</td>\
									<td style="vertical-align:top; padding: 20px;">\
										<table>\
											<tr><td><input id="propTotal" type="checkbox"' + previewKeyUpEvent + previewMouseUpEvent + ' /><label style="cursor:pointer;" for="propTotal" lang-text="js_Total">Total</label></td></tr>\
											<tr><td><input id="propVG" type="checkbox"' + previewKeyUpEvent + previewMouseUpEvent + ' /><label style="cursor:pointer;" for="propVG" lang-text="js_VisualGroup">Visual Group</label></td></tr>\
											<tr>\
												<td>\
													<div style="width:100%;">\
														<div class="multi-valued-check-advanced"><label msv="L" msvs="L,M,R" id="labelJ" onclick="javascript:UpdateMSV(\'labelJ\', ' + forInstantReports + ');">L</label></div>\
														<label onclick="javscript:UpdateMSV(\'labelJ\', ' + forInstantReports + ');" style="cursor:pointer;" lang-text="js_LabelJustification">Label Justification</label>\
													</div>\
												</td>\
											</tr>\
											<tr>\
												<td>\
													<div style="width:100%;">\
													<div class="multi-valued-check-advanced"><label msv="&nbsp;" msvs="&nbsp;,L,M,R" id="valueJ" onclick="javascript:UpdateMSV(\'valueJ\', ' + forInstantReports + ');">&nbsp;</label></div>\
													<label onclick="javascript:UpdateMSV(\'valueJ\', ' + forInstantReports + ');" style="cursor:pointer;" lang-text="js_ValueJustification">Value Justification</label>\
													</div>\
												</td>\
											</tr>\
										</table>\
									</td>\
									' + preview + '\
								</tr>\
							</table>\
						</td>\
					</tr>\
				</table>\
			</div>\
		</div>';
	return markup;
}

//-------------------------------------------------------------------------------------------------------------------

//Initialization----------------------------------------------------------------------------------------------------------------------
var reportName;
var urlSettings;
var initialized;
var nrvConfig;

function InitializePopup() {
	fieldPopup = jq$("#data-source-field").dialog({
		autoOpen: false,
		width: GetDialogWidth(),
		height: "auto",
		modal: true,
		buttons: {
			"OK": function () {
				switchTabAfterRefreshCycle = true;
				updateFieldProperties(FP_CollectProperties());
				jq$(this).dialog("close");
			},
			"Cancel": function () {
				jq$(this).dialog("close");
			}
		},
		open: function () {
			jq$(this).parents(".ui-dialog-buttonpane button:eq(0)").focus();
		},
		show: { effect: "fade", duration: 200 },
		hide: { effect: "fade", duration: 200 }
	});
}

function InitializeResponsiveUI() {
	jq$(window).resize(function () {
		ChangeFieldsWidth();
	});
	ChangeFieldsWidth();
}

function InitViewerTabs() {
	var filtersTab = jq$('#tab1');
	var fieldsTab = jq$('#tab2');

	if (filtersTab.length > 0) {
		jq$('#htmlFilters').hide();
		filtersTab.append(GetLoadingHtml());
	}
	if (fieldsTab.length > 0) {
		jq$('#fieldPropertiesDialogContainer').hide();
		jq$('#fieldsCtlTable').hide();
		fieldsTab.append(GetLoadingHtml());
	}
}

function ChangeFieldsWidth() {
	var fieldsControl = jq$('#fieldsCtlTable');
	if (!fieldsControl)
		return;
	if (jq$(window).width() < 900)
		fieldsControl.addClass('narrow');
	else
		fieldsControl.removeClass('narrow');
}

function InitializeViewer() {
	initialized = false;
	InitializePopup();
	InitializeResponsiveUI();
	InitViewerTabs();
	document.getElementById('tab1a').click();
	GetReportViewerConfig();
}

function GetReportViewerConfig() {
	var wwidth = jq$(window).width();
	var wheight = jq$(window).height();
    var rnParam = '';
    if (reportName)
    	rnParam = reportName;
    var requestString = 'wscmd=reportviewerconfig&wsarg0=' + wwidth + '&wsarg1=' + wheight + '&wsarg2=' + rnParam;
	AjaxRequest('./rs.aspx', requestString, GotReportViewerConfig, null, 'reportviewerconfig');
}

function GotReportViewerConfig(returnObj, id) {
	if (id != 'reportviewerconfig' || returnObj == undefined || returnObj == null)
		return;
	nrvConfig = returnObj;
	nrvConfig.serverDelimiter = '?';
	if (nrvConfig.ResponseServerUrl.indexOf('?') >= 0)
		nrvConfig.serverDelimiter = '&';
	if (document.getElementById('rlhref') != null)
		document.getElementById('rlhref').href = nrvConfig.ReportListUrl;
	urlSettings = new UrlSettings(nrvConfig.ResponseServerUrl);
	var delimiter = '';
	if (urlSettings.urlRsPage.lastIndexOf(nrvConfig.serverDelimiter) != urlSettings.urlRsPage.length - 1)
		delimiter = nrvConfig.serverDelimiter;
	responseServer = new AdHoc.ResponseServer(urlSettings.urlRsPage + delimiter, 0);
	responseServerWithDelimeter = responseServer.ResponseServerUrl;
	if (nrvConfig.UseBulkCsv) {
		var csvExportBtn = document.getElementById('csvExportBtn');
		if (csvExportBtn != null)
			csvExportBtn.onclick = function () { responseServer.OpenUrlWithModalDialogNewCustomRsUrl('rs.aspx?output=BULKCSV', 'aspnetForm', 'reportFrame', nrvConfig.ResponseServerUrl); };
	}
	ChangeTopRecords(nrvConfig.InitialResults, false);
	if (urlSettings.reportInfo.exportType != null) {
		responseServer.OpenUrlWithModalDialogNewCustomRsUrl(nrvConfig.ResponseServerUrl + nrvConfig.serverDelimiter + 'output=' + urlSettings.reportInfo.exportType, 'aspnetForm', 'reportFrame', nrvConfig.ResponseServerUrl);
	};
	ApplySecurityOptions();
	if (!initialized)
		GetRenderedReportSet(false);
	//http://fogbugz.izenda.us/default.asp?15858#BugEvent.185759
	/*if (!nrvConfig.AllowRTFExportFormat)
		jq$("#RTFExportButton").remove();*/

    if (nrvConfig.ClearReportName)
    	AppendReportNameTitle(nrvConfig.ClearReportName);
}

function ApplySecurityOptions() {
	if (nrvConfig.ReportIsReadOnly == true) {
		jq$('.hide-readonly').hide();
		jq$('#btnSaveDirect').attr('disabled', 'disabled');
	}
	if (nrvConfig.ReportIsViewOnly == true)
		jq$('.hide-viewonly').hide();
	if (nrvConfig.ReportIsLocked == true)
		jq$('.hide-locked').hide();
}

function GetRenderedReportSet(invalidateInCache, additionalParams, caller) {
	jq$('#renderedReportDiv').html(GetLoadingHtml());

	var requestString = 'wscmd=getrenderedreportset',
		urlParams = [],
		queryParameters = {},
		re = /([^&=]+)=([^&]*)/g, m;

	while (m = re.exec(location.search.substring(1))) {
		var pName = decodeURIComponent(m[1]).toLowerCase();
		queryParameters[pName] = decodeURIComponent(m[2]);
		if (pName != 'rn')
			urlParams.push(pName + '=' + m[2]);
	}

	if (queryParameters['rn'] != null && queryParameters['rn'].length > 0 && !initialized)
		requestString += '&wsarg0=' + (reportName = queryParameters['rn']);
	if (invalidateInCache)
		urlParams.push('iic=1');
	if (additionalParams)
		urlParams.push(additionalParams);

	AjaxRequest('./rs.aspx' + (urlParams.length > 0 ? "?" + urlParams.join("&") : ""), requestString, GotRenderedReportSet, null, 'getrenderedreportset');
}

function GotRenderedReportSet(returnObj, id) {
	if (id != 'getrenderedreportset' || !returnObj)
		return;
	ReportScripting.loadReportResponse(returnObj, "#renderedReportDiv");

	AdHoc.Utility.InitGaugeAnimations(null, null, false);
	// Dirty workaround for IE8
	if (jq$.support.opacity == false)
		setTimeout(function () { jq$('body')[0].className = jq$('body')[0].className; }, 200);
	if (!initialized) {
		initialized = true;
		GetReportViewerConfig();
		FirstLoadInit();
	}
	else {
		jq$('#htmlFilters :input').prop('disabled', true);
		GetFiltersData();
	}
}

function FirstLoadInit() {
	var designerBtn = document.getElementById('designerBtn');
	var reportParam = '';
	if (reportName != undefined && reportName != null)
		reportParam = '?rn=' + reportName;
	designerBtn.onclick = function () { window.location = nrvConfig.ReportDesignerUrl + reportParam; };
	jq$('#navdiv ul li a').click(function () {
		var currentTab = jq$(this).attr('href');
		var vis = jq$(currentTab).is(':visible');
		jq$('#tabsContentsDiv > div').hide();
		jq$(this).parent().removeClass('active');
		if (!vis) {
			jq$(currentTab).show();
			document.getElementById('updateBtnPC').style.display = 'none';
		}
		else {
			document.getElementById('updateBtnPC').style.display = '';
			setTimeout(function () {
				jq$('#navdiv ul li').removeClass('active');
				jq$('#navdiv ul li a').removeClass('active');
			}, 100);
		}
	});

    InitializeFields();
    RefreshPivots();   
    GetFiltersData();
}

function AppendReportNameTitle(forcedReportName){
	var fieldWithRn = document.getElementById('clearReportNameFor2ver');
	var rnVal;
	if (forcedReportName)
		rnVal = forcedReportName;
	else if (fieldWithRn != null)
		rnVal = fieldWithRn.value;
	else if (reportName == undefined || reportName == null)
		rnVal = '';
	else
		rnVal = reportName;

	while (rnVal.indexOf('+') >= 0) {
		rnVal = rnVal.replace('+', ' ');
	}
	var frNodes = rnVal.split(nrvConfig.CategoryCharacter);
	var namePart = frNodes[frNodes.length - 1];
	var catPart = frNodes.length <= 1 ? '' : frNodes[frNodes.length - 2];
	if (namePart.indexOf('&') >= 0) {
		namePart = namePart.substr(0, namePart.indexOf('&'));
	}
	if (catPart.indexOf('&') >= 0) {
		catPart = catPart.substr(0, catPart.indexOf('&'));
	}
	var rntc = namePart;
	var selfInd = rntc.indexOf('(SELF)_');
	if (selfInd >= 0)
		rntc = rntc.substr(0, selfInd);
	var autoInd = rntc.indexOf('(AUTO)_');
	if (autoInd == 0)
		rntc = rntc.substr(7);
	var hdr = '<h1 style=\"margin-left:40px;\">' + rntc + (catPart.length <= 0 ? '' : ' <i>(' + catPart + ')</i>') + '</h1>';
	var repHeader = document.getElementById('repHeader');
	repHeader.innerHTML = hdr;
}

function GetDatasourcesList() {
	fieldsDataObtained = false;
	var requestString = 'wscmd=crsdatasources';
	AjaxRequest('./rs.aspx', requestString, GotDatasourcesList, null, 'crsdatasources');
}

function GotDatasourcesList(returnObj, id) {
	if (id != 'crsdatasources' || returnObj == undefined || returnObj == null)
		return;
	if (returnObj.SelectionsList == null || returnObj.SelectionsList.length == 0)
		return;

	// Show Fiends content instead of the Loading
	if (jq$('#fieldsCtlTable').is(':hidden'))
		jq$('#fieldsCtlTable').show();
	if (jq$('#fieldPropertiesDialogContainer').is(':hidden'))
		jq$('#fieldPropertiesDialogContainer').show();
	jq$('#tab2 #loadingDiv').hide();

	selectionsList = returnObj.SelectionsList;
	var dsUlList = document.getElementById('dsUlList');
	var allOpt = new Option();
	allOpt.value = "###all###";
	allOpt.text = IzLocal.Res('js_All', 'All');
	dsUlList.add(allOpt);
	for (var dsCnt = 0; dsCnt < selectionsList.length; dsCnt++) {
		var opt = new Option();
		opt.value = selectionsList[dsCnt].DbName;
		opt.text = selectionsList[dsCnt].FriendlyName;
		dsUlList.add(opt);
	}
	if (selectionsList.length == 1) {
		var dsUlList = document.getElementById('dsUlList');
		dsUlList.style.display = 'none';
	}
	currentDatasource = -1;
	wereChecked.length = 0;
	fieldsDataObtained = true;
	RefreshFieldsList();
	//var saveControls = document.getElementById('saveControls');
	//if (returnObj.CanSaveReport)
	//    saveControls.style.display = '';
	//else
	//    saveControls.style.display = 'none';
}

function InitializeFields() {
	GetDatasourcesList();
}

function CheckNewCatName() {
	var newCategoryName = document.getElementById('newCategoryName');
	if (newCategoryName.value == IzLocal.Res('js_CreateNew', '(Create new)'))
		ShowNewCatDialog();
	else
		prevCatValue = newCategoryName.value;
}

function CancelSave() {
	var saveAsDialog = document.getElementById('saveAsDialog');
	saveAsDialog.style.display = 'none';
}

function CancelAddCategory() {
	var newCatDialog = document.getElementById('newCatDialog').style.display = 'none';
	var saveAsDialog = document.getElementById('saveAsDialog');
	var windowHeight = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : document.body.clientHeight;
	saveAsDialog.style.height = windowHeight + 'px';
	saveAsDialog.style.paddingTop = ((windowHeight / 2) - 100) + 'px';
	saveAsDialog.style.display = '';
	var newCategoryName = document.getElementById('newCategoryName');
	newCategoryName.value = prevCatValue;
}
//---------------------------------------------------------------------------------------------------------------------------

//Tooltip functionality from old reportViewer----------------------------------------------------------------------------
// Href tooltips functions
var FADINGTOOLTIP;
var FadingTooltipList = {};
var wnd_height, wnd_width;
var tooltip_height, tooltip_width;
var tooltip_shown = false;
var transparency = 100;
var timer_id = 1;

function DisplayTooltip(tooltip_url) {
	tooltip_shown = (tooltip_url != "") ? true : false;

	if (tooltip_shown) {
		FADINGTOOLTIP = FadingTooltipList[tooltip_url];
		if (FADINGTOOLTIP == null) {
			var obody = document.getElementsByTagName('body')[0];
			var frag = document.createDocumentFragment();
			FADINGTOOLTIP = document.createElement('div');
			FADINGTOOLTIP.style.border = "darkgray 1px outset";
			FADINGTOOLTIP.style.width = "auto";
			FADINGTOOLTIP.style.height = "auto";
			FADINGTOOLTIP.style.color = "black";
			FADINGTOOLTIP.style.backgroundColor = "white";
			FADINGTOOLTIP.style.position = "absolute";
			FADINGTOOLTIP.style.zIndex = 1000;
			frag.appendChild(FADINGTOOLTIP);
			obody.insertBefore(frag, obody.firstChild);
			window.onresize = UpdateWindowSize;
			document.onmousemove = AdjustToolTipPosition;

			FADINGTOOLTIP.innerHTML = IzLocal.Res('js_Loading', "Loading...") + "<br><image src='" + nrvConfig.ResponseServerUrl + nrvConfig.serverDelimiter + "image=loading.gif'/>";
			//EBC_GetData(tooltip_url, null, DisplayTooltip_CallBack, tooltip_url);
			responseServer.RequestData(tooltip_url, DisplayTooltip_CallBack);
		}
		FADINGTOOLTIP.style.display = "";
		FADINGTOOLTIP.style.visibility = "visible";
		FadingTooltipList[tooltip_url] = FADINGTOOLTIP;
	}
	else {
		if (FADINGTOOLTIP != null) {
			clearTimeout(timer_id);
			FADINGTOOLTIP.style.visibility = "hidden";
			FADINGTOOLTIP.style.display = "none";
		}
	}
}

function DisplayTooltip_CallBack(url, xmlHttpRequest) {
	if (xmlHttpRequest.status == 200) {
		var toolTip = FadingTooltipList[url];
		toolTip.innerHTML = xmlHttpRequest.responseText;
		if (toolTip == FADINGTOOLTIP)
			tooltip_height = (FADINGTOOLTIP.style.pixelHeight) ? FADINGTOOLTIP.style.pixelHeight : FADINGTOOLTIP.offsetHeight;
		transparency = 0;
		AdHoc.Utility.InitGaugeAnimations(null, null, true);
	}
}

function AdjustToolTipPosition(evt) {
	evt = (evt) ? evt : window.event;
	if (tooltip_shown) {
		var scrollTop = document.documentElement.scrollTop + document.body.scrollTop;
		var scrollLeft = document.documentElement.scrollLeft + document.body.scrollLeft;
		WindowLoading();

		var offset_y = evt.clientY + tooltip_height + 15;
		var top = evt.clientY + scrollTop + 15;
		if (offset_y > wnd_height) {
			var offset_y2 = evt.clientY - tooltip_height - 15;
			top = evt.clientY - tooltip_height + scrollTop - 15;
			if (offset_y2 < 0) {
				top = (wnd_height - tooltip_height) / 2 + scrollTop;
			}
		}

		var offset_x = evt.clientX + tooltip_width + 15;
		var left = evt.clientX + scrollLeft + 15;
		if (offset_x > wnd_width) {
			var dx = offset_x - wnd_width;
			var offset_x2 = evt.clientX - tooltip_width - 15;
			var left2 = evt.clientX - tooltip_width + scrollLeft - 15;
			if (offset_x2 < 0) {
				var dx2 = -offset_x2;
				if (dx2 < dx)
					left = left2;
			}
			else {
				left = left2;
			}
		}
		if (tooltip_height > 100) {
			top = scrollTop + evt.clientY - tooltip_height / 3;
		}

		FADINGTOOLTIP.style.left = left + 'px';
		FADINGTOOLTIP.style.top = top + 'px';
	}
}

function WindowLoading() {
	tooltip_width = (FADINGTOOLTIP.style.pixelWidth) ? FADINGTOOLTIP.style.pixelWidth : FADINGTOOLTIP.offsetWidth;
	tooltip_height = (FADINGTOOLTIP.style.pixelHeight) ? FADINGTOOLTIP.style.pixelHeight : FADINGTOOLTIP.offsetHeight;
	UpdateWindowSize();
}

function ToolTipFading() {
	if (transparency <= 100) {
		FADINGTOOLTIP.style.filter = "alpha(opacity=" + transparency + ")";
		transparency += 5;
		timer_id = setTimeout('ToolTipFading()', 35);
	}
}

function UpdateWindowSize() {
	wnd_height = document.body.clientHeight;
	wnd_width = document.body.clientWidth;
}
//---------------------------------------------------------------------------------------------------------
